package com.yidian.shenghuoquan.commodity.ui.coupon

import androidx.activity.viewModels
import androidx.fragment.app.Fragment
import androidx.viewpager2.adapter.FragmentStateAdapter
import com.google.android.material.tabs.TabLayoutMediator
import com.yidian.common.XRouterPathConstants
import com.yidian.common.mvvm.BaseMvvmActivity
import com.yidian.shenghuoquan.commodity.R
import com.yidian.shenghuoquan.commodity.databinding.CommodityActivityCommodityManagementBinding
import com.yidian.shenghuoquan.commodity.ui.coupon.fragment.CommodityListFragment
import com.yidian.shenghuoquan.commodity.ui.coupon.viewmodel.CommodityManagementViewModel
import com.yidian.xpage.XPageManager
import com.yidian.xpage.XPageViewProtocol

/**
 * author: yinjiacheng
 * date: 7/1/21 8:05 PM
 * description: 商品管理
 */
class CommodityManagementActivity : BaseMvvmActivity<CommodityActivityCommodityManagementBinding, CommodityManagementViewModel>(),
  XPageViewProtocol {

  companion object {
    // 传入H5商品id
    private const val EXTRA_COMMODITY_ID = "coupon_id"
  }

  override val layoutId: Int = R.layout.commodity_activity_commodity_management

  override val vm: CommodityManagementViewModel by viewModels()

  override fun initView() {
    vm.commodityStatusList.observe(this, {
      // ViewPager2设置适配器
      binding.vpCommodityList.adapter = object : FragmentStateAdapter(this) {
        override fun getItemCount() = it.size

        override fun createFragment(position: Int): Fragment {
          return CommodityListFragment(it[position])
        }
      }

      // TabLayout与ViewPager2绑定
      TabLayoutMediator(
        binding.tlCommodityList, binding.vpCommodityList
      ) { tab, position ->
        tab.text = it[position].name
      }.attach()
    })
    // 请求商品状态列表
    vm.requestCommodityStatusList()

    //发布商品
    binding.tvCommodityPublish.setOnClickListener {
      // 跳转商品发布页面 新发布商品不传id
      XPageManager.push(XRouterPathConstants.PUBLISH_COUPONS_ACTIVITY, null)
    }
  }

  override fun getXPageName(): String {
    return XRouterPathConstants.COMMODITY_MANAGEMENT
  }
}
